MSTNMIX.MLE = function(Y, w, xi, S, la, nu, g, eqnu = F, method = "CMQ", true.clus=true.class, tol = 1e-6, max.iter, per)
{
begin = proc.time()[1]
if(is.vector(Y) == T) Y = as.matrix(Y)
n = nrow(Y); p = ncol(Y); iter = 0
if(g == 1)
{
w = 1
xi = matrix(xi,p,g)
la = matrix(la,p,g)
S = array(S,dim=c(p,p,g))
}
detS = rep(NA,g); S.inv = array(NA, dim=c(p,p,g))
A = Delta = matrix(NA, g, n)
be = matrix(NA, p, g)
for(i in 1:g)
{
eig.S = eigen(S[,,i]); detS[i] = prod(eig.S$va)
S.inv[,,i] = eig.S$ve %*% diag(1/eig.S$va,p) %*% t(eig.S$ve)
S.root = eig.S$ve %*% diag(sqrt(eig.S$va),p) %*% t(eig.S$ve)
u = solve(S.root)%*%(t(Y)-xi[,i])
A[i,] = colSums(la[,i]*u)
Delta[i,] = colSums(u^2)
be[,i] = c(solve(S.root)%*%la[,i])
}
logtp = lgamma(.5*(nu+p))-lgamma(.5*nu)-.5*(log(detS)+p*log(pi*nu)+(nu+p)*log(1+Delta/nu))
wZ = t(w*2*exp(logtp)*pnorm(A))
indv.den = rowSums(wZ)
logli.old = sum(log(indv.den))
logli.seq = logli.old; ell.seq = NULL
cat("\t\t MSTNMIX-ECM (g = ",g,")\n",sep="")
cat(paste(rep("=",60),sep="",collapse=""),"\n")
cat('iter =', iter, '\tlogli =', logli.old, '\n')
CMQ.nu = function(nu, const)
{
val = nu*log(nu/2)/2-lgamma(nu/2)+const*nu/2
return(-val)
}
CML.nu = function(Z, Delta, detS, nu)
{
logtp = lgamma(.5*(nu+p))-lgamma(.5*nu)-.5*(log(detS)+p*log(pi*nu)+(nu+p)*log(1+Delta/nu))- sum(Z * logtp)
}
repeat
{
#E-step
iter = iter + 1
Z = wZ / indv.den 
ni = colSums(Z)
hs1 = A + dnorm(A)/pnorm(A)
tau = (nu+p)/(nu+Delta)
kap = digamma(.5*(nu+p))-log(.5*(nu+Delta))
hs1 = t(hs1); tau = t(tau); kap = t(kap)
Ztau = Z * tau; Zs1 = Z * hs1
const = colSums(Z*(kap - tau))
# M-step
w = ni / n
for(i in 1:g)
{
xi.p1 = solve(S.inv[,,i]*sum(Ztau[,i])+ni[i]*be[,i]%*%t(be[,i]))
xi.p2 = S.inv[,,i]%*%colSums(Ztau[,i]*Y)+be[,i]%*%t(be[,i])%*%
colSums(Z[,i]*Y)-be[,i]*sum(Zs1[,i],na.rm=T)
xi[,i] = c(xi.p1 %*% xi.p2)
cent = t(Y) - xi[,i]
S[,,i] = cent%*%(Ztau[,i]*t(cent))/ni[i]
eig.S = eigen(S[,,i]); detS[i] = prod(eig.S$va)
S.inv[,,i] = eig.S$ve %*% diag(1/eig.S$va,p) %*% t(eig.S$ve)
S.root = eig.S$ve %*% diag(sqrt(eig.S$va),p) %*% t(eig.S$ve)
B1 = cent%*%(Z[,i]*t(cent))
B2 = colSums(Zs1[,i]*t(cent),na.rm=T)
be[,i] = c(solve(B1)%*%B2)
la[,i] = c(S.root%*%be[,i])
u = solve(S.root)%*%cent
A[i,] = colSums(la[,i]*u)
Delta[i,] = colSums(u^2)
}
if(method == "CMQ")
{
if(eqnu == F)
{
for(i in 1:g)
{
nu[i] = optim(par = nu[i], fn = CMQ.nu, method = "L-BFGS-B",
lower = 1e-3, upper = Inf, const = const[i]/ni[i])$par
}
}
if(eqnu == T)
{
nu = optim(par = nu[1], fn = CMQ.nu, method = "L-BFGS-B",
lower = 1e-3, upper = Inf, const = sum(const)/n)$par
nu = rep(nu, g)
}
}
if(method == "CML")
{
if(eqnu == F)
{
for(i in 1:g)
{
tmp = try(optim(par = nu[i], fn = CML.nu, method = "L-BFGS-B", lower = 1e-3,
upper = Inf, Delta=Delta[i,], Z=Z[,i], detS=detS[i])$par, silent = F)
if(!inherits(tmp, "try-error")){nu[i] = tmp}
}
}
if(eqnu == T)
{
tmp = try(optim(par = nu[1], fn = CML.nu, method = "L-BFGS-B", lower = 1e-3,
upper = Inf, Delta=Delta, Z=t(Z), detS=detS)$par, silent = F)
if(!inherits(tmp, "try-error")){nu = rep(tmp,g)}
}
}
logtp = lgamma(.5*(nu+p))-lgamma(.5*nu)-.5*(log(detS)+p*log(pi*nu)+(nu+p)*log(1+Delta/nu))
wZ = t(w*2*exp(logtp)*pnorm(A))
indv.den = rowSums(wZ)
logli.new = sum(log(indv.den)); logli.seq = c(logli.seq, logli.new)
differ = logli.new - logli.old
if(iter %% per == 0)
cat('iter =', iter, '\tlogli =', logli.new, '\tdiff =', differ, '\tnu =', nu, '\n')
#if(differ < tol | iter == max.iter) break
 if(iter >= 2)
    {
     ak = (logli.seq[iter+1] - logli.seq[iter]) / (logli.seq[iter] - logli.seq[iter-1])
     ell = logli.seq[iter] + (logli.seq[iter+1] - logli.seq[iter]) / (1 - ak)
     ell.seq = c(ell.seq, ell)
     if(abs(ell - logli.new) < tol | iter == max.iter) break
    }
logli.old = logli.new
}

 Z = wZ / indv.den 
 post.clus = matrix(apply(Z,1,order), nrow=g)[g,]
 if(length(unique(post.clus))==length(unique(true.clus)))
 CCR=1-error.rate(post.clus, true.clus)
 else
  CCR=sum(apply(as.matrix(table(post.clus,true.clus)),2,max))/n
  ARI=adjustedRandIndex(post.clus, true.clus)

cat(paste(rep("=",60),sep="",collapse=""),"\n")
cat('iter =', iter, '\tlogli =', logli.new, '\tdiff =', differ, '\n')
num.para = g-1+2*p*g+p*(p+1)/2*g+ifelse(eqnu,1,g)
aic = -2*logli.new+2*num.para
bic = -2*logli.new+log(n)*num.para
bic2 = -bic/2
ENT = - sum(Z*log(Z+1e-10))
post.clus = matrix(apply(Z, 1, order), nrow = g)[g,]#̾Zwܭ@s 
ICL = bic + 2* ENT
end = proc.time()[1]
cpu.time=end - begin
cat('It tooks ', cpu.time, 'seconds\n\n')
if(eqnu==T) nu=nu[1]
#mds=c(logli=logli.new,num.para=num.para,AIC=aic,BIC=bic, ENT=ENT, ICL=ICL, ARI=ARI, CCR=CCR)
mds=c(logli=logli.new, AIC=aic,BIC=bic, ARI=ARI, CCR=CCR)
cat("model information:\n"); print(mds); cat("\n")
para = list(w=w,xi=xi,S=S,la=la,nu=nu)
#out=c(cpu.time, logli.new, bic, nu, la)
#write(t(out), 'd:/simu-stco2012/out/outmstn.txt', ncol=8, app=T)
#return(list(mds=mds, para=para, post.clus=post.clus))
return(list(mds=mds, para=para))
}

init.para=function(Y, g, clust)
{
  n = nrow(Y)
  p = ncol(Y)
  w = rep(NA, g)
  xi = matrix(NA, p, g)
  S = array(NA,dim=c(p,p,g))
  la = matrix(0,p,g)
  nu = rep(10,g)
  for(i in 1:g)
  {
  suby = Y[clust==i,]
  w[i] = nrow(suby)/n
  xi[,i] = colMeans(suby)
  S[,,i] = cov(suby)
  }
  list(w=w, xi=xi, S=S, la=la, nu=nu)
}