m(list=ls(all=TRUE))
library(mixsmsn)
library(EMMIXskew)

setwd('  ')

source('NIG.mix.generator.R')
source('MIXNMV.BS.EM.r')
source('MSTNMIX.EM.r')
source('EM---SAL.r')

B=300
g=3;dd=3
psi=c(5,7,5); chi=c(4,8,6); 
mu=list(c(3,2,1),c(8,5,6),c(7,4,7)); p=c(2/7,2/7,3/7)
gamma=list(c(1,2,9),c(1,1,6),c(5,3,5))
sigma1=matrix(c(1.25,0.25,0.5,0.25,1.1,-0.2,0.5,-0.2,0.8),dd,dd);
sigma2=matrix(c(0.818,0.15,0.25,0.15,1.125,0.815,0.25,0.815,2.20),dd,dd)#
sigma3=matrix(c(1.818,0.5,1.25,0.5,1.15,0.71,1.25,0.71,1.20),dd,dd)
sigma=list(sigma1,sigma2,sigma3)

S = array(NA, dim=c(dd,dd,g))
S[,,1]=sigma1;S[,,2]=sigma2;S[,,3]=sigma3
la = matrix(NA,dd,g)
for(i in 1:g) la[,i]=gamma[[i]]
xi = matrix(NA,dd,g)
for(i in 1:g) xi[,i]=mu[[i]]

MN.out = MT.out = MSN.out = MST.out = MSTN.out = NMVBS.out = MSAL.out = matrix(NA, B, 5)
sn.out = st.out = ssl.out = scn.out = matrix(NA, B, 5)
for(i in 1:B)
{
  cat('B = ', B, ", rep.num = ", i, '\n')
  cat(paste(rep("*",100),sep="",collapse=""),"\n")
  Y=NIG.mix.generator(chi, psi, p=p,mu ,sigma,gamma,sample.size= 500)
  true.class = Y$class
  x=Y$data
  
  MN.fit= EmSkew(dat=x, g=3, distr="mvn",clus=true.class, debug=F)
  MN.out[i,]=print(c(MN.logli=MN.fit$logli, MN.aic=MN.fit$aic, MN.bic=MN.fit$bic, MN.ARI=adjustedRandIndex(MN.fit$clust, true.class), MN.CCR=1-error.rate(MN.fit$clust, true.class)))
  
  MT.fit= EmSkew(dat=x, g=3, distr="mvt",clus=true.class, debug=F)
  MT.out[i,]=print(c(MT.logli=MT.fit$logli, MT.aic=MT.fit$aic, MT.bic=MT.fit$bic, MT.ARI=adjustedRandIndex(MT.fit$clust, true.class), MT.CCR=1-error.rate(MT.fit$clust, true.class)))
  
  init.par= init.para(Y=x, g=g, clust=true.class)
  MSTN.fit=MSTNMIX.MLE(Y=x, w=init.par$w, xi=init.par$xi, S=init.par$S, la=init.par$la, nu=c(4,4,4), g=3, eqnu = F, method = "CMQ", tol = 1e-3, max.iter=1000, per=1000)
  MSTN.out[i,]=MSTN.fit$mds
  
  NMVBS.fit=MIXNMV.BS.EM(t(x), mu, gamma, sigma, alpha=c(1,1,1), p, tol=1e-3, max.iter=1000, per=1000, class=true.class, Erro=F)
  NMVBS.out[i,]=NMVBS.fit$mds
  
  SAL.fit=MIXSAL.EM(t(x), mu, gamma, sigma, p, tol=1e-5, max.iter=100, per=1000, class=true.class)
  MSAL.out[i,]=SAL.fit$mds
  detach("package:HyperbolicDist", unload=TRUE)
  
  sn.mix = smsn.mmix(x, nu=3, g=3, get.init = TRUE, criteria = TRUE, 
                     error = 0.001, iter.max = 1000,group = TRUE, family = "Skew.normal")
  
  group.sn=sn.mix$group
  ari.sn=as.numeric(rand.index(group.sn, true.class)[2])
  mcr.sn=1-error.rate(group.sn, true.class)
  sn.out[i,]=c(sn.mix$logLik, sn.mix$aic, sn.mix$bic, ari.sn, mcr.sn)
  
  st.mix = smsn.mmix(x, nu=3, g=3, get.init = TRUE, criteria = TRUE, 
                     error = 0.001, iter.max = 1000,group = TRUE, family = "Skew.t")
  
  group.st=st.mix$group
  ari.st=as.numeric(rand.index(group.st, true.class)[2])
  mcr.st=error.rate(group.st, true.class)
  st.out[i,]=c(st.mix$logLik, st.mix$aic, st.mix$bic, ari.st, mcr.st)
  
  cn.mix = smsn.mmix(x, nu=c(0.1,0.1), g=3, get.init = TRUE, criteria = TRUE, 
                     error = 0.0001, iter.max = 1000,group = TRUE, family = "Skew.cn")
  
  group.cn=cn.mix$group
  ari.cn=as.numeric(rand.index(group.cn, true.class)[2])
  mcr.cn=error.rate(group.cn, true.class)
  scn.out[i,]=c(cn.mix$logLik, cn.mix$aic, cn.mix$bic, ari.cn, mcr.cn)
  
  ssl.mix = smsn.mmix(x, nu=3, g=3, get.init = TRUE, criteria = TRUE, 
                      error = 0.001, iter.max = 1000,group = TRUE, family = "Skew.slash")
  
  group.ssl=ssl.mix$group
  ari.ssl=as.numeric(rand.index(group.ssl, true.class)[2])
  mcr.ssl=error.rate(group.ssl, true.class)
  ssl.out[i,]=c(ssl.mix$logLik, ssl.mix$aic, ssl.mix$bic, ari.ssl, mcr.ssl)
  
}

colMeans(NMVBS.out)
colMeans(MSTN.out)
colMeans(MN.out)
colMeans(MT.out)
colMeans(MSAL.out)

colMeans(sn.out)
colMeans(st.out)
colMeans(ssl.out)
colMeans(scn.out)




