rm(list=ls(all=TRUE))
setwd('  ')
library(gbs)
library(mnormt)
rmnbsmix=function(n, pp, mu, tau, sigma, alpha)
{
  g=length(pp)
  d=length(mu[[1]])
  y=list(g)
  ni=rmultinom(1, size =n, prob =pp)
  #class=rep(1:g, c(ni))
  x=matrix(numeric(n*d),d,n)
  for (i in 1:g)
  {
    w=rgbs(ni[i],alpha[i])
    z=t(rmnorm(ni[i], mean = rep(0, d), sigma[[i]]))
    for(j in 1:ni[i])
    {
      x=matrix(c(mu[[i]]+tau[[i]]*w[j]+sqrt(w[j])*z[,j],x[,-n]),d,n)
    }
  }
  return(t(x))
}

n=1000
dd=3;    B=500
alphaa=c(0.5,1,2)
mu=list(c(3,5,7),c(1,4,6),c(-1,1,0))
pp=c(0.4,.4,0.2)
tau=list(c(1,2,3),c(2,3,2),c(-1,1,2))
sigma1=matrix(c(1.2,-0.2,-0.4,-0.2,0.8,-0.6,-0.4,-0.6,1.1),dd,dd)
sigma2=matrix(c(0.8,0.4,0.3,0.4,1.45,0.6,0.3,0.6,1.6),dd,dd)
sigma3=matrix(c(1,-0.5,-0.3,-0.5,1.25,0.8,-0.3,0.8,1.4),dd,dd)
sigma=list(sigma1,sigma2,sigma3)

mu1=mu2=mu3=tau1=tau2=tau3=alpha=p=matrix(0,3,B)
vech = cbind(unlist(mapply(':',1:dd, dd)),rep(1:dd, dd:1))
sigma1=sigma2=sigma3=matrix(0,dim(vech)[1],B)

SE=0

i=0
repeat
{i=i+1
Y=rmnbsmix(n, pp, mu, tau, sigma, alphaa)

mix.BS=MIXNMV.BS.EM(t(Y), mu, tau, sigma, alphaa,pp,tol=1e-4, max.iter=1000,10000,class,Erro=F)
if(mix.BS$iter>1){
  print(i)
  mu1[,i]=mix.BS$para$mu[[1]]
  mu2[,i]=mix.BS$para$mu[[2]]
  mu3[,i]=mix.BS$para$mu[[3]]
  
  ###########################################-
  tau1[,i]=mix.BS$para$tau[[1]]
  tau2[,i]=mix.BS$para$tau[[2]]
  tau3[,i]=mix.BS$para$tau[[3]]
  
  #######################################--
  
  alpha[,i]=mix.BS$para$alpha
  p[,i]=mix.BS$para$p
  
  ###############
  sigma1[,i]=mix.BS$para$sigma[[1]][vech]
  sigma2[,i]=mix.BS$para$sigma[[2]][vech]
  sigma3[,i]=mix.BS$para$sigma[[3]][vech]
}
else{i= i-1}
if(i>=B) break
}

mean.mu1=round(rowMeans(mu1),3)
mean.mu2=round(rowMeans(mu2),3)
mean.mu3=round(rowMeans(mu3),3)

sd.mu1=round(apply(mu1,1,sd),3)
sd.mu2=round(apply(mu2,1,sd),3)
sd.mu3=round(apply(mu3,1,sd),3)

AB.mu1=round(rowMeans(abs(mu1-mu[[1]])),3)
AB.mu2=round(rowMeans(abs(mu2-mu[[2]])),3)
AB.mu3=round(rowMeans(abs(mu3-mu[[3]])),3)

MSE.mu1=round(rowMeans((mu1-mu[[1]])^2),3)
MSE.mu2=round(rowMeans((mu2-mu[[2]])^2),3)
MSE.mu3=round(rowMeans((mu3-mu[[3]])^2),3)

####################################-
mean.tau1=round(rowMeans(tau1),3)
mean.tau2=round(rowMeans(tau2),3)
mean.tau3=round(rowMeans(tau3),3)

sd.tau1=round(apply(tau1,1,sd),3)
sd.tau2=round(apply(tau2,1,sd),3)
sd.tau3=round(apply(tau3,1,sd),3)

AB.tau1=round(rowMeans(abs(tau1-tau[[1]])),3)
AB.tau2=round(rowMeans(abs(tau2-tau[[2]])),3)
AB.tau3=round(rowMeans(abs(tau3-tau[[3]])),3)

MSE.tau1=round(rowMeans((tau1-tau[[1]])^2),3)
MSE.tau2=round(rowMeans((tau2-tau[[2]])^2),3)
MSE.tau3=round(rowMeans((tau3-tau[[3]])^2),3)

###################################-
mean.alpha=round(rowMeans(alpha),3)
mean.p=round(rowMeans(p),3)

sd.alpha=round(apply(alpha,1,sd),3)
sd.p=round(apply(p,1,sd),3)

AB.alpha=round(rowMeans(abs(alpha-alphaa)),3)
AB.p=round(rowMeans(abs(p-pp)),3)

MSE.alpha=round(rowMeans((alpha-alphaa)^2),3)
MSE.p=round(rowMeans((p-pp)^2),3)

####################################-
mean.sigma1=round(rowMeans(sigma1),3)
mean.sigma2=round(rowMeans(sigma2),3)
mean.sigma3=round(rowMeans(sigma3),3)

sd.sigma1=round(apply(sigma1,1,sd),3)
sd.sigma2=round(apply(sigma2,1,sd),3)
sd.sigma3=round(apply(sigma3,1,sd),3)

AB.sigma1=round(rowMeans(abs(sigma1-sigma[[1]][vech])),3)
AB.sigma2=round(rowMeans(abs(sigma2-sigma[[2]][vech])),3)
AB.sigma3=round(rowMeans(abs(sigma3-sigma[[3]][vech])),3)

MSE.sigma1=round(rowMeans((sigma1-sigma[[1]][vech])^2),3)
MSE.sigma2=round(rowMeans((sigma2-sigma[[2]][vech])^2),3)
MSE.sigma3=round(rowMeans((sigma3-sigma[[3]][vech])^2),3)


########### out ##
c(mean.mu1, mean.tau1,mean.sigma1, mean.alpha[1], mean.p[1])
c(mean.mu2, mean.tau2,mean.sigma2, mean.alpha[2], mean.p[2])
c(mean.mu3, mean.tau3,mean.sigma3, mean.alpha[3])


c(sd.mu1,sd.tau1, sd.sigma1, sd.alpha[1], sd.p[1])
c(sd.mu2,sd.tau2, sd.sigma2, sd.alpha[2], sd.p[2])
c(sd.mu3,sd.tau3, sd.sigma3, sd.alpha[3])

c(AB.mu1,AB.tau1, AB.sigma1, AB.alpha[1],AB.p[1])
c(AB.mu2,AB.tau2, AB.sigma2, AB.alpha[2],AB.p[2])
c(AB.mu3,AB.tau3, AB.sigma3, AB.alpha[3])

c(MSE.mu1,MSE.tau1,MSE.sigma1,MSE.alpha[1],MSE.p[1])
c(MSE.mu2,MSE.tau2,MSE.sigma2,MSE.alpha[2],MSE.p[2])
c(MSE.mu3,MSE.tau3,MSE.sigma3,MSE.alpha[3])


